import React from 'react';
import style from './index.less';
import mocks from '../../mock/chronicTable.js'

// 量表 具体信息页面
class ScaleTable extends React.Component{
  constructor(props){
    super(props);
  }

  render(){
    return <div className={style['tableBox']}>
            <h1>密西根糖尿病神经筛查表（MDNS）</h1>
            <p>MDNS可与MNSI联合应用以确定是否存在周围神经病变，在一段时间内对患者进行评分可以评估疾病的进展情况。</p>
            <table className={style['table']}>
              <thead>
                <tr>
                  {mocks.data.title.map((v,i)=>{
                    return <td>{v.name}</td>
                  })}  
                </tr>
              </thead>
              <tbody>
                {mocks.data.details.map((v,i)=>{
                    return <tr>
                    <td>{v.name}</td>
                    <td>
                      {v.details.map((it,index)=>{
                        return <td style={{display:'block'}}>{it.detailName}</td>
                      })}
                    </td>
                    <td></td>
                    <td></td>
                    </tr>
                  })} 
              </tbody>
            </table>
            <div>
              <p>
                1. 计算方法：<br/>
              感觉损伤得分=左右两侧感觉检查项目的分数之和
              肌力得分=左右两侧肌力检查项目的分数之和
              反射得分=左右两侧反射检查项目的分数之和
              体格检查得分=感觉损伤得分+肌力得分+反射得分
              </p>
              <p>
                2. 临床体格检查部分：<br/>
              最低得分0  最高得分46， 分数越高，周围神经病越重
              </p>
            </div>
          </div>
  }
}
export default ScaleTable;